﻿# -*- coding: utf-8 -*-
#######################################################################################################
#
#    MediaPortal for Dreambox OS
#
#    Coded by MediaPortal Team (c) 2013-2021
#
#  This plugin is open source but it is NOT free software.
#
#  This plugin may only be distributed to and executed on hardware which
#  is licensed by Dream Property GmbH. This includes commercial distribution.
#  In other words:
#  It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
#  to hardware which is NOT licensed by Dream Property GmbH.
#  It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
#  on hardware which is NOT licensed by Dream Property GmbH.
#
#  This applies to the source code as a whole as well as to parts of it, unless explicitely
#  stated otherwise.
#
#  If you want to use or modify the code or parts of it, permission from the authors is necessary.
#  You have to keep OUR license and inform us about any modification, but it may NOT be distributed
#  other than under the conditions noted above.
#
#  As an exception regarding modifcations, you are NOT permitted to remove
#  any copy protections implemented in this plugin or change them for means of disabling
#  or working around the copy protections, unless the change has been explicitly permitted
#  by the original authors. Also decompiling and modification of the closed source
#  parts is NOT permitted.
#
#  Advertising with this plugin is NOT allowed.
#
#  For other uses, permission from the authors is necessary.
#
#######################################################################################################

from Plugins.Extensions.MediaPortal.plugin import _
from Plugins.Extensions.MediaPortal.resources.imports import *

agent='Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36'
json_headers = {
	'Accept':'application/json',
	'Accept-Language':'de,en-US;q=0.7,en;q=0.3',
	'X-Requested-With':'XMLHttpRequest',
	'Content-Type':'application/x-www-form-urlencoded',
	}
default_cover = "file://%s/porngo.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
cookies = CookieJar()

class porngoGenreScreen(MPScreen):

	def __init__(self, session, url='', name='Genre'):
		self.url = url
		self.name = name
		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft,
			"cancel" : self.keyCancel,
			"nextBouquet" : self.keyPageUp,
			"prevBouquet" : self.keyPageDown,
		}, -1)

		self['title'] = Label("PornGO.com")
		self['ContentTitle'] = Label(self.name+":")
		if self.url:
			self['F2'] = Label(_("Page"))
			self['Page'] = Label(_("Page:"))
		self.keyLocked = True
		self.page = 1
		self.lastpage = 1

		self.suchString = ''

		self.cat1 = []
		self.cat2 = []
		self.filmliste = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		self.filmliste = []
		self.keyLocked = True
		if self.url:
			url = self.url + str(self.page) + "/"
		else:
			url = "https://www.porngo.com/categories/"
		twAgentGetPage(url, agent=agent, cookieJar=cookies).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		if self.url:
			self.getLastPage(data, 'class="pagination">(.*?)spot_footer', '.*(?:\/|">)(\d+)')
			pornstars = MPfindall(self, 'class="thumb">.*?href="(.*?)".*?title="(.*?)".*?<img\ssrc="(.*?)"', data, re.S)
			if pornstars:
				for (Url, Title, Image) in pornstars:
					self.filmliste.append((Title, Url, Image))
			self.ml.setList(map(self._defaultlistleft, self.filmliste))
		else:
			self.filmliste.insert(0, ("Pornstars", "https://www.porngo.com/models/alphabetical/", default_cover))
			self.filmliste.insert(0, ("Top Rated", "https://www.porngo.com/top-rated/", default_cover))
			self.filmliste.insert(0, ("Most Viewed", "https://www.porngo.com/most-popular/", default_cover))
			self.filmliste.insert(0, ("Newest", "https://www.porngo.com/latest-updates/", default_cover))
			self.filmliste.insert(0, ("--- Search ---", "callSuchen", default_cover))
			Cats1 = MPfindall(self, '<a class="nav-menu__link" href="(.*?)">(.*?)</a>', data, re.S)
			if Cats1:
				for (Url, Title) in Cats1:
					Url = "https://www.porngo.com" + Url
					self.cat1.append((Title, Url, default_cover))
				self.cat1.sort()
			parse = re.search('class="letter-section">(.*?)class="letter">#', data, re.S)
			if parse:
				Cats2 = MPfindall(self, 'class="letter-block__item">.*?href="(.*?)".*?<span>(.*?)</span>', parse.group(1), re.S)
				if Cats2:
					for (Url, Title) in Cats2:
						self.cat2.append((Title, Url, default_cover))
					self.cat2.sort()
			if len(self.cat1) > 0:
				self.filmliste.append((400 * "—", None, default_cover))
				self.filmliste.extend(self.cat1)
			if len(self.cat2) > 0:
				self.filmliste.append((400 * "—", None, default_cover))
				self.filmliste.extend(self.cat2)
			self.ml.setList(map(self._defaultlistcenter, self.filmliste))
		self.ml.moveToIndex(0)
		self.keyLocked = False
		self.showInfos()

	def showInfos(self):
		cover = self['liste'].getCurrent()[0][2]
		CoverHelper(self['coverArt']).getCover(cover)

	def keyOK(self):
		if self.keyLocked:
			return
		Name = self['liste'].getCurrent()[0][0]
		Link = self['liste'].getCurrent()[0][1]
		if Name == "--- Search ---":
			self.suchen(suggest_func=self.getSuggestions)
		elif Name == "Pornstars":
			self.session.open(porngoGenreScreen, Link, Name)
		elif Link:
			self.session.open(porngoFilmScreen, Link, Name)

	def SuchenCallback(self, callback = None):
		if callback is not None and len(callback):
			Name = "--- Search ---"
			self.suchString = callback
			Link = urllib.quote(self.suchString).replace(' ', '-')
			self.session.open(porngoFilmScreen, Link, Name)

	def getSuggestions(self, text, max_res):
		url = "https://www.porngo.com/search_suggestion.php?query=%s" % urllib.quote_plus(text)
		d = twAgentGetPage(url, agent=agent, headers=json_headers, timeout=5)
		d.addCallback(self.gotSuggestions, max_res)
		d.addErrback(self.gotSuggestions, max_res, err=True)
		return d

	def gotSuggestions(self, suggestions, max_res, err=False):
		list = []
		if not err and type(suggestions) in (str, buffer):
			suggestions = json.loads(suggestions)
			for item in suggestions["suggestions"]:
				li = item['value']
				list.append(str(li))
				max_res -= 1
				if not max_res: break
		elif err:
			printl(str(suggestions),self,'E')
		return list

class porngoFilmScreen(MPScreen, ThumbsHelper):

	def __init__(self, session, Link, Name):
		self.Link = Link
		self.Name = Name
		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)
		ThumbsHelper.__init__(self)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"5" : self.keyShowThumb,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft,
			"nextBouquet" : self.keyPageUp,
			"prevBouquet" : self.keyPageDown,
			"green" : self.keyPageNumber
		}, -1)

		self['title'] = Label("PornGO.com")
		self['ContentTitle'] = Label("Genre: %s" % self.Name)
		self['F2'] = Label(_("Page"))

		self['Page'] = Label(_("Page:"))
		self.keyLocked = True
		self.page = 1
		self.lastpage = 1

		self.filmliste = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		self.keyLocked = True
		self['name'].setText(_('Please wait...'))
		self.filmliste = []
		if re.match(".*Search", self.Name):
			url = "https://www.porngo.com/search/%s/%s/" % (self.Link, str(self.page))
		else:
			url = "%s%s/" % (self.Link, str(self.page))
		twAgentGetPage(url, agent=agent, cookieJar=cookies).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		self.getLastPage(data, 'class="pagination">(.*?)spot_footer', '.*(?:\/|">)(\d+)')
		Movies = MPfindall(self, 'class="thumb item\s{0,1}">.*?href="(.*?)".*?<img\ssrc="(.*?)".*?duration">(.*?)</span>.*?class="thumb__title">(.*?)</div.*?class="thumb__text">(\d+.)\sviews</span>', data, re.S)
		if Movies:
			for (Url, Image, Runtime, Title, Views) in Movies:
				Title = stripAllTags(Title).strip()
				self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views))
		if len(self.filmliste) == 0:
			self.filmliste.append((_('No videos found!'), None, None, '', ''))
		self.ml.setList(map(self._defaultlistleft, self.filmliste))
		self.ml.moveToIndex(0)
		self.keyLocked = False
		self.th_ThumbsQuery(self.filmliste, 0, 1, 2, None, None, self.page, self.lastpage, mode=1)
		self.showInfos()

	def showInfos(self):
		title = self['liste'].getCurrent()[0][0]
		url = self['liste'].getCurrent()[0][1]
		pic = self['liste'].getCurrent()[0][2]
		runtime = self['liste'].getCurrent()[0][3]
		views = self['liste'].getCurrent()[0][4]
		self['name'].setText(title)
		self['handlung'].setText("Runtime: %s\nViews: %s" % (runtime, views))
		CoverHelper(self['coverArt']).getCover(pic)

	def keyOK(self):
		if self.keyLocked:
			return
		Link = self['liste'].getCurrent()[0][1]
		if Link:
			twAgentGetPage(Link, cookieJar=cookies, agent=agent).addCallback(self.parseVideo).addErrback(self.dataError)

	def parseVideo(self, data):
		url = None
		streams = MPfindall(self, 'class="video-links__link"\shref="(http[s]?://(?:www.|)porngo.com/{0,1}/get_file.*?)".*?>(\d+k{0,1})', data, re.S)
		if streams:
			import requests
			max = 0
			def url_ok(url):
				r = requests.head(url, allow_redirects=True)
				return r.status_code
			for (stream, res) in reversed(streams):
				res = res.replace('4k','2160')
				if int(res) <= 720:
					if int(res) > max:
						check = url_ok(stream)
						if check == 200:
							url = stream
							max = int(res)
					else:
						break
				#elif mp_globals.model in ["one","two"]:
				#	if int(res) > max:
				#		check = url_ok(stream)
				#		if check == 200:
				#			url = stream
				#			max = int(res)
				#	else:
				#		break
		else:
			streams = MPfindall(self, '<source src="(.*?)"', data, re.S)
			if streams:
				url = streams[-1]
		if url:
			tw_agent_hlp = TwAgentHelper(cookieJar=cookies)
			tw_agent_hlp.getRedirectedUrl(url).addCallback(self.getStream).addErrback(self.dataError)

	def getStream(self, url):
		if url.startswith('//'):
			url = 'https:' + url
		Title = self['liste'].getCurrent()[0][0]
		mp_globals.player_agent = agent
		self.session.open(SimplePlayer, [(Title, url)], showPlaylist=False, ltype='porngo')