﻿# -*- coding: utf-8 -*-
#######################################################################################################
#
#    MediaPortal for Dreambox OS
#
#    Coded by MediaPortal Team (c) 2013-2021
#
#  This plugin is open source but it is NOT free software.
#
#  This plugin may only be distributed to and executed on hardware which
#  is licensed by Dream Property GmbH. This includes commercial distribution.
#  In other words:
#  It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
#  to hardware which is NOT licensed by Dream Property GmbH.
#  It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
#  on hardware which is NOT licensed by Dream Property GmbH.
#
#  This applies to the source code as a whole as well as to parts of it, unless explicitely
#  stated otherwise.
#
#  If you want to use or modify the code or parts of it, permission from the authors is necessary.
#  You have to keep OUR license and inform us about any modification, but it may NOT be distributed
#  other than under the conditions noted above.
#
#  As an exception regarding modifcations, you are NOT permitted to remove
#  any copy protections implemented in this plugin or change them for means of disabling
#  or working around the copy protections, unless the change has been explicitly permitted
#  by the original authors. Also decompiling and modification of the closed source
#  parts is NOT permitted.
#
#  Advertising with this plugin is NOT allowed.
#
#  For other uses, permission from the authors is necessary.
#
#######################################################################################################

from Plugins.Extensions.MediaPortal.plugin import _
from Plugins.Extensions.MediaPortal.resources.imports import *
from Plugins.Extensions.MediaPortal.resources.decrypt import decrypturl
from Plugins.Extensions.MediaPortal.resources.configlistext import ConfigListScreenExt

agent='Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36'
cookies = CookieJar()
username = ""
password = ""
LoggedIn = False

config_mp.mediaportal._0dayporn_username = ConfigText(default="", fixed_size=False)
config_mp.mediaportal._0dayporn_password = ConfigPassword(default="", fixed_size=False)
config_mp.mediaportal._datoporn_username = ConfigText(default="", fixed_size=False)
config_mp.mediaportal._datoporn_password = ConfigPassword(default="", fixed_size=False)

class slutloadGenreScreen(MPScreen):

	def __init__(self, session, mode):
		self.mode = mode

		global default_cover
		global username
		global password
		global LoggedIn
		LoggedIn = False
		if self.mode == "slutload":
			self.portal = "Slutload.com"
			self.baseurl = "https://www.slutload.com"
			default_cover = "file://%s/slutload.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "madthumbs":
			self.portal = "MadThumbs.com"
			self.baseurl = "http://www.madthumbs.com"
			default_cover = "file://%s/madthumbs.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "fapster":
			self.portal = "Fapster.xxx"
			self.baseurl = "https://fapster.xxx"
			default_cover = "file://%s/fapster.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "vqtube":
			self.portal = "VQTube.com"
			self.baseurl = "https://vqtube.com"
			default_cover = "file://%s/vqtube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "megatube":
			self.portal = "MegaTube.xxx"
			self.baseurl = "https://www.megatube.xxx"
			default_cover = "file://%s/megatube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "watchmygf":
			self.portal = "WatchMyGF.me"
			self.baseurl = "https://www.watchmygf.me"
			default_cover = "file://%s/watchmygf.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "watchmyexgf":
			self.portal = "WatchMyExGF.net"
			self.baseurl = "https://www.watchmyexgf.net"
			default_cover = "file://%s/watchmyexgf.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "tropictube":
			self.portal = "TropicTube.com"
			self.baseurl = "https://www.tropictube.com"
			default_cover = "file://%s/tropictube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "pornfd":
			self.portal = "PornFD.com"
			self.baseurl = "http://www.pornfd.com"
			default_cover = "file://%s/pornfd.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "pornbimbo":
			self.portal = "PornBimbo.com"
			self.baseurl = "http://pornbimbo.com"
			default_cover = "file://%s/pornbimbo.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "boundhub":
			self.portal = "BoundHub.com"
			self.baseurl = "https://www.boundhub.com"
			default_cover = "file://%s/boundhub.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "eroclips":
			self.portal = "EroClips.org"
			self.baseurl = "http://www.eroclips.org"
			default_cover = "file://%s/eroclips.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "punishbang":
			self.portal = "PunishBang.com"
			self.baseurl = "https://www.punishbang.com"
			default_cover = "file://%s/punishbang.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "camvideos":
			self.portal = "CamVideos.tv"
			self.baseurl = "http://www.camvideos.tv"
			default_cover = "file://%s/camvideos.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "anonv":
			self.portal = "Anon-V.com"
			self.baseurl = "https://anon-v.com"
			default_cover = "file://%s/anonv.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "mrdeepfakes":
			self.portal = "MrDeepFakes.com"
			self.baseurl = "https://mrdeepfakes.com"
			default_cover = "file://%s/mrdeepfakes.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "ebony8":
			self.portal = "Ebony8.com"
			self.baseurl = "https://www.ebony8.com"
			default_cover = "file://%s/ebony8.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "camuploads":
			self.portal = "CamUploads.com"
			self.baseurl = "https://www.camuploads.com"
			default_cover = "file://%s/camuploads.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "datoporn":
			self.portal = "DatoPorn.com"
			self.baseurl = "https://dato.porn"
			default_cover = "file://%s/datoporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
			username = str(config_mp.mediaportal._datoporn_username.value)
			password = str(config_mp.mediaportal._datoporn_password.value)
		elif self.mode == "mypornhere":
			self.portal = "MyPornHere.com"
			self.baseurl = "https://www.mypornhere.com"
			default_cover = "file://%s/mypornhere.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "filtercams":
			self.portal = "FilterCams.com"
			self.baseurl = "https://filtercams.com"
			default_cover = "file://%s/filtercams.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "alotporn":
			self.portal = "AlotPorn.com"
			self.baseurl = "https://www.alotporn.com"
			default_cover = "file://%s/alotporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.mode == "0dayporn":
			self.portal = "0DayPorn.com"
			self.baseurl = "https://0dayporn.com"
			default_cover = "file://%s/0dayporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
			username = str(config_mp.mediaportal._0dayporn_username.value)
			password = str(config_mp.mediaportal._0dayporn_password.value)
		elif self.mode == "cambro":
			self.portal = "CamBro.tv"
			self.baseurl = "https://www.cambro.tv"
			default_cover = "file://%s/cambro.png" % (config_mp.mediaportal.iconcachepath.value + "logos")

		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"blue": self.keySetup
		}, -1)

		self['title'] = Label(self.portal)
		self['ContentTitle'] = Label("Genre:")
		if self.mode in ["0dayporn", "datoporn"]:
			self['F4'] = Label(_("Setup"))
		self.keyLocked = True

		self.suchString = ''

		self.filmliste = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		self['name'].setText(_('Please wait...'))
		self.extcat = []
		self.maincat = []
		if self.mode == "watchmygf":
			self.maincat.insert(0, ("Longest", "longest#duration"))
			self.maincat.insert(0, ("Most Favorited", "new#most_favourited"))
			self.maincat.insert(0, ("Most Commented", "new#most_commented"))
			self.maincat.insert(0, ("Top Rated", "rated#rating"))
			self.maincat.insert(0, ("Most Viewed", "popular#video_viewed"))
			self.maincat.insert(0, ("Newest", "new#post_date"))
			self.maincat.insert(0, ("--- Search ---", "callSuchen"))
		elif self.mode == "alotporn":
			self.maincat.insert(0, ("Top Rated", "rated#rating"))
			self.maincat.insert(0, ("Most Viewed", "popular#video_viewed"))
			self.maincat.insert(0, ("Newest", "recent#post_date"))
			self.maincat.insert(0, ("--- Search ---", "callSuchen"))
		else:
			self.maincat.insert(0, ("Longest", "duration"))
			if self.mode == "punishbang":
				self.maincat.insert(0, ("Recently Featured", "last_time_view_date"))
			self.maincat.insert(0, ("Most Favorited", "most_favourited"))
			self.maincat.insert(0, ("Most Commented", "most_commented"))
			self.maincat.insert(0, ("Top Rated", "rating"))
			self.maincat.insert(0, ("Most Viewed", "video_viewed"))
			self.maincat.insert(0, ("Newest", "post_date"))
			self.maincat.insert(0, ("--- Search ---", "callSuchen"))
		self.keyLocked = True
		if self.mode == "tropictube":
			url = "%s/c/" % self.baseurl
		elif self.mode == "punishbang":
			url = "%s/categories/?mode=async&function=get_block&block_id=list_categories_categories_list&sort_by=title&from=" % self.baseurl
		else:
			url = "%s/categories/" % self.baseurl
		twAgentGetPage(url, agent=agent).addCallback(self.genreData).addErrback(self.dataError)
		if self.mode == "vqtube":
			twAgentGetPage(url+'2/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'3/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'4/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'5/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'6/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'7/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'8/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'9/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
			twAgentGetPage(url+'10/', agent=agent).addCallback(self.genreData).addErrback(self.dataError)
		elif self.mode == "punishbang":
			twAgentGetPage(url+'2', agent=agent).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		Cats = MPfindall(self, 'class="item".*?href="(.*?)" title="(.*?)"', data, re.S)
		if not Cats:
			Cats = MPfindall(self, 'class="thumb category".*?href="(.*?)" title="(.*?)"', data, re.S)
			if not Cats:
				Cats = MPfindall(self, 'js-item".*?href="(.*?)".*?title="(.*?)"', data, re.S)
		if Cats:
			for (Url, Title) in Cats:
				if not "scat" in Title.lower() and not "toilet" in Title.lower() and not "pony" in Title.lower():
					self.extcat.append((upperString(Title), Url.strip('/')))
		if 'class="list-categories-tags">' in data:
			parse = re.search('class="list-categories-tags">(.*?)</div>', data, re.S)
			if parse:
				Cats = MPfindall(self, '<a href="(.*?)">(.*?)<em>\d+</em></a>', parse.group(1), re.S)
				if Cats:
					for (Url, Title) in Cats:
						self.extcat.append((upperString(Title.strip()), Url.strip('/')))

		if 'class="categories-tags-holder">' in data:
			parse = re.search('class="categories-tags-holder">(.*?)class="content-footer"', data, re.S)
			if parse:
				Cats = MPfindall(self, '<a href="(.*?)".*?class="text">(.*?)</div.*?<span>\d+</span>', parse.group(1), re.S)
				if Cats:
					for (Url, Title) in Cats:
						self.extcat.append((upperString(Title.strip()), Url.strip('/')))
		# remove duplicates
		self.extcat = list(set(self.extcat))
		self.extcat.sort()
		self.filmliste = []
		self.filmliste.extend(self.maincat)
		self.filmliste.extend(self.extcat)
		self.ml.setList(map(self._defaultlistcenter, self.filmliste))
		self['name'].setText('')
		self.keyLocked = False

	def keyOK(self):
		if self.keyLocked:
			return
		Name = self['liste'].getCurrent()[0][0]
		Link = self['liste'].getCurrent()[0][1]
		if Name == "--- Search ---":
			self.suchen()
		elif Link:
			self.session.open(slutloadFilmScreen, Link, Name, self.portal, self.baseurl)

	def SuchenCallback(self, callback = None):
		if callback is not None and len(callback):
			Name = "--- Search ---"
			self.suchString = callback
			Link = urllib.quote(self.suchString).replace(' ', '-')
			self.session.open(slutloadFilmScreen, Link, Name, self.portal, self.baseurl)

	def keySetup(self):
		if not self.mode in["0dayporn", "datoporn"]:
			return
		if mp_globals.isDreamOS:
			self.session.openWithCallback(self.setupCallback, slutloadSetupScreen, self.mode, self.portal, is_dialog=True)
		else:
			self.session.openWithCallback(self.setupCallback, slutloadSetupScreen, self.mode, self.portal)

	def setupCallback(self, answer=False):
		if answer:
			global username
			global password
			global LoggedIn
			LoggedIn = False
			cookies.clear()
			if self.mode == "0dayporn":
				username = str(config_mp.mediaportal._0dayporn_username.value)
				password = str(config_mp.mediaportal._0dayporn_password.value)
			elif self.mode == "datoporn":
				username = str(config_mp.mediaportal._datoporn_username.value)
				password = str(config_mp.mediaportal._datoporn_password.value)

class slutloadSetupScreen(MPSetupScreen, ConfigListScreenExt):

	def __init__(self, session, mode, portal):
		self.mode = mode
		self.portal = portal
		MPSetupScreen.__init__(self, session, skin='MP_PluginSetup')

		self['title'] = Label(self.portal + " " + _("Setup"))
		self['F4'] = Label('')
		self.setTitle(self.portal + " " + _("Setup"))

		self.list = []
		ConfigListScreenExt.__init__(self, self.list)

		if self.mode == "0dayporn":
			self.list.append(getConfigListEntry(_("Username:"), config_mp.mediaportal._0dayporn_username))
			self.list.append(getConfigListEntry(_("Password:"), config_mp.mediaportal._0dayporn_password))
		elif self.mode == "datoporn":
			self.list.append(getConfigListEntry(_("Username:"), config_mp.mediaportal._datoporn_username))
			self.list.append(getConfigListEntry(_("Password:"), config_mp.mediaportal._datoporn_password))

		self["config"].setList(self.list)

		self["setupActions"] = ActionMap(["SetupActions"],
		{
			"ok":		self.saveConfig,
			"cancel":	self.exit
		}, -1)

	def saveConfig(self):
		for x in self["config"].list:
			x[1].save()
		configfile_mp.save()
		self.close()

	def exit(self):
		self.close()

class slutloadFilmScreen(MPScreen, ThumbsHelper):
	blacklist = ['scat', 'poo', 'shit', 'toilet', 'meal', 'lunch', 'gaia', 'chinese femdom']

	def __init__(self, session, Link, Name, portal, baseurl):
		self.Link = Link
		self.Name = Name
		self.portal = portal
		self.baseurl = baseurl

		global default_cover
		global username
		global password
		global LoggedIn
		if self.portal == "Slutload.com":
			default_cover = "file://%s/slutload.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "MadThumbs.com":
			default_cover = "file://%s/madthumbs.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "Fapster.xxx":
			default_cover = "file://%s/fapster.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "VQTube.com":
			default_cover = "file://%s/vqtube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "MegaTube.xxx":
			default_cover = "file://%s/megatube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "WatchMyGF.me":
			default_cover = "file://%s/watchmygf.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "WatchMyExGF.net":
			default_cover = "file://%s/watchmyexgf.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "TropicTube.com":
			default_cover = "file://%s/tropictube.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PornFD.com":
			default_cover = "file://%s/pornfd.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PornBimbo.com":
			default_cover = "file://%s/pornbimbo.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "BoundHub.com":
			default_cover = "file://%s/boundhub.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "EroClips.org":
			default_cover = "file://%s/eroclips.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "PunishBang.com":
			default_cover = "file://%s/punishbang.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "CamVideos.tv":
			default_cover = "file://%s/camvideos.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "Anon-V.com":
			default_cover = "file://%s/anonv.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "MrDeepFakes.com":
			default_cover = "file://%s/mrdeepfakes.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "Ebony8.com":
			default_cover = "file://%s/ebony8.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "CamUploads.com":
			default_cover = "file://%s/camuploads.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "CamUploads.com":
			default_cover = "file://%s/camuploads.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "DatoPorn.com":
			default_cover = "file://%s/datoporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
			username = str(config_mp.mediaportal._datoporn_username.value)
			password = str(config_mp.mediaportal._datoporn_password.value)
		elif self.portal == "MyPornHere.com":
			default_cover = "file://%s/mypornhere.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "FilterCams.com":
			default_cover = "file://%s/filtercams.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "AlotPorn.com":
			default_cover = "file://%s/alotporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
		elif self.portal == "0DayPorn.com":
			default_cover = "file://%s/0dayporn.png" % (config_mp.mediaportal.iconcachepath.value + "logos")
			username = str(config_mp.mediaportal._0dayporn_username.value)
			password = str(config_mp.mediaportal._0dayporn_password.value)
		elif self.portal == "CamBro.tv":
			default_cover = "file://%s/cambro.png" % (config_mp.mediaportal.iconcachepath.value + "logos")

		MPScreen.__init__(self, session, skin='MP_Plugin', default_cover=default_cover)
		ThumbsHelper.__init__(self)

		self["actions"] = ActionMap(["MP_Actions"], {
			"ok" : self.keyOK,
			"0" : self.closeAll,
			"cancel" : self.keyCancel,
			"5" : self.keyShowThumb,
			"up" : self.keyUp,
			"down" : self.keyDown,
			"right" : self.keyRight,
			"left" : self.keyLeft,
			"nextBouquet" : self.keyPageUp,
			"prevBouquet" : self.keyPageDown,
			"green" : self.keyPageNumber
		}, -1)

		self['title'] = Label(self.portal)
		self['ContentTitle'] = Label("Genre: %s" % self.Name)
		self['F2'] = Label(_("Page"))

		self['Page'] = Label(_("Page:"))
		self.keyLocked = True
		self.page = 1
		self.lastpage = 1

		self.filmliste = []
		self.ml = MenuList([], enableWrapAround=True, content=eListboxPythonMultiContent)
		self['liste'] = self.ml

		self.onLayoutFinish.append(self.loadPage)

	def loadPage(self):
		cookies.clear()
		LoggedIn = False
		self.keyLocked = True
		self['name'].setText(_('Please wait...'))
		self.filmliste = []
		if re.match(".*Search", self.Name):
			if self.portal == "PunishBang.com":
				url = "%s/search/%s/?mode=async&function=get_block&block_id=list_videos_videos_list_search_result&category_ids=&sort_by=&from=%s" % (self.baseurl, self.Link, str(self.page))
			elif self.portal == "WatchMyExGF.net":
				url = "%s/porn/%s/?mode=async&function=get_block&block_id=list_videos_videos_list_search_result&q=%s&category_ids=&sort_by=&from_videos=%s&from_albums=%s" % (self.baseurl, self.Link, self.Link.replace('-','+'), str(self.page), str(self.page))
			elif self.portal == "AlotPorn.com":
				url = "%s/vid/%s/?mode=async&function=get_block&block_id=list_videos_videos_list_search_result&q=%s&category_ids=&sort_by=&from_videos=%s&from_albums=%s" % (self.baseurl, self.Link, self.Link.replace('-','+'), str(self.page), str(self.page))
			else:
				if self.portal == "PornFD.com":
					stop = False
					for x in self.blacklist:
						if x.lower() in self.Link.lower():
							stop = True
					if stop:
						self.Link = ''
				url = "%s/search/%s/?mode=async&function=get_block&block_id=list_videos_videos_list_search_result&q=%s&category_ids=&sort_by=&from_videos=%s&from_albums=%s" % (self.baseurl, self.Link, self.Link.replace('-','+'), str(self.page), str(self.page))
		else:
			if self.Link.startswith('http'):
				if self.Link.split('/')[-1].isdigit():
					fix = '1'
				else:
					fix = ''
				if self.portal in ["MegaTube.xxx", "WatchMyGF.me"] and not "/tag/" in self.Link:
					delim = ''
				else:
					delim = '/'
				url = "%s%s%s?mode=async&function=get_block&block_id=list_videos_common_videos_list&sort_by=post_date" % (self.Link, delim, fix)
				if self.page > 1:
					url = url + "&from=%s" % str(self.page)
			else:
				if self.portal in ["WatchMyGF.me", "AlotPorn.com"]:
					if self.Name in ["Newest"]:
						if self.portal == "AlotPorn.com":
							blockid = "list_videos_latest_videos_list"
						else:
							blockid = "list_videos_common_videos_list"
						url = "%s/%s/%s/?mode=async&function=get_block&block_id=%s&sort_by=%s&from=%s" % (self.baseurl, self.Link.split('#')[0], str(self.page), blockid, self.Link.split('#')[-1], str(self.page))
					else:
						blockid = "list_videos_common_videos_list"
						url = "%s/%s/?mode=async&function=get_block&block_id=%s&sort_by=%s&from=%s" % (self.baseurl, self.Link.split('#')[0], blockid, self.Link.split('#')[-1], str(self.page))
				else:
					if self.portal == "PunishBang.com":
						blockid = "list_videos_popular_today_videos"
					else:
						blockid = "list_videos_most_recent_videos"
					url = "%s/?mode=async&function=get_block&block_id=%s&sort_by=%s" % (self.baseurl, blockid, self.Link)
					if self.page > 1:
						url = url + "&from=%s" % str(self.page)
		twAgentGetPage(url, agent=agent, cookieJar=cookies).addCallback(self.genreData).addErrback(self.dataError)

	def genreData(self, data):
		if self.portal in ["WatchMyGF.me", "TropicTube.com"]:
			self.getLastPage(data, 'class="pagination(.*?)(?:class="next"|</ul>)', '.*(?:from:|from_albums:|<span>)(\d{2,5})(?:</span>|\")')
		elif self.portal == "PunishBang.com":
			self.getLastPage(data, 'class="pagination"(.*?)(?:item--next|</ul>)', '.*(?:from:|from_albums:|<span>)(\d{2,5})(?:</span>|\")')
		elif self.portal == "WatchMyExGF.net":
			self.getLastPage(data, 'class="paginator(.*?)(?:class="next"|</ul>)', '.*(?:from:|from_albums:|<span>)(\d{2,5})(?:</span>|\")')
		elif self.portal == "PornBimbo.com":
			if ">Load more...<" in data:
				self.lastpage = self.page + 1
			self['page'].setText(str(self.page) + ' / ' + str(self.lastpage))
		else:
			self.getLastPage(data, 'class="pagination"(.*?)>Last<', '.*[from:|>](\d+)["|<]')
		data = data.replace('class="item private', 'class="item ')
		if 'class="item   ' in data:
			data = data.split('class="item   "')
		elif 'class="item  "' in data:
			data = data.split('class="item  "')
		elif 'class="item "' in data:
			data = data.split('class="item "')
		elif 'class="item"' in data:
			data = data.split('class="item"')
		elif 'class="thumb item"' in data:
			data = data.split('class="thumb item"')
		elif 'js-item">' in data:
			data = data.split('js-item">')
		elif 'class="video-box-card item"' in data:
			data = data.split('class="video-box-card item"')
		for item in data:
			if self.portal == "WatchMyGF.me":
				Movie = MPfindall(self, 'href="(.*?)".*?class="time">(.*?)</div.*?alt="(.*?)".*?data-src="(.*?)".*?class="eye">(.*?)</span', item, re.S)
				if Movie:
					for (Url, Runtime, Title, Image, Views) in Movie:
						Runtime = Runtime.replace('h','').replace('m','').replace('s','')
						Views = Views.replace(',','')
						if Image.startswith('//'):
							Image = "http:" + Image
						self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views, ''))
			elif self.portal == "WatchMyExGF.net":
				Movie = MPfindall(self, 'href="(.*?)" title="(.*?)".*?data-original="(.*?)".*?class="far fa-clock">(.*?)</span.*?class="fas fa-eye">(.*?)</span', item, re.S)
				if Movie:
					for (Url, Title, Image, Runtime, Views) in Movie:
						Runtime = stripAllTags(Runtime.replace('h','').replace('m','').replace('s','')).strip()
						Views = stripAllTags(Views.replace(' ','')).strip()
						if Image.startswith('//'):
							Image = "http:" + Image
						self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views, ''))
			elif self.portal == "TropicTube.com":
				Movie = MPfindall(self, 'href="(.*?)" title="(.*?)".*?data-original="(.*?)".*?class="thumb_info">.*?<em>(.*?)</em>.*?<em>(.*?)</em>.*?<em>(.*?)</em>', item, re.S)
				if Movie:
					for (Url, Title, Image, Runtime, Views, Added) in Movie:
						Views = Views.replace(' ','').strip()
						Runtime = Runtime.replace('h','').replace('m','').replace('s','').strip()
						if Image.startswith('//'):
							Image = "http:" + Image
						Added = Added.strip()
						self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views, Added))
			elif self.portal == "PunishBang.com":
				Movie = MPfindall(self, 'href="(.*?)".*?class="flag">(.*?)</span>.*?data-src="(.*?)".*?alt="(.*?)".*?icon--eye">.*?card__text">(.*?)</span>', item, re.S)
				if Movie:
					for (Url, Runtime, Image, Title, Views) in Movie:
						Views = Views.replace(' ','').strip()
						Runtime = Runtime.replace('h','').replace('m','').replace('s','').strip()
						if Image.startswith('//'):
							Image = "http:" + Image
						self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views, ''))
			elif self.portal == "AlotPorn.com":
				Movie = MPfindall(self, 'href="(.*?)" title="(.*?)".*?(?:src|data-original)="(?!data:image/)(.*?)".*?class="is-hd">(?:<i>HD</i>&nbsp; |)(.*?)</span>', item, re.S)
				if Movie:
					for (Url, Title, Image, Runtime) in Movie:
						Runtime = Runtime.replace('h','').replace('m','').replace('s','').strip()
						if Image.startswith('//'):
							Image = "http:" + Image
						self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, '', ''))
			elif self.portal == "CamBro.tv":
				if not 'private' in item:
					Movie = MPfindall(self, 'href="(.*?)" title="(.*?)".*?(?:src|data-original)="(?!data:image/)(.*?)".*?class="duration">(.*?)</div>', item, re.S)
					if Movie:
						for (Url, Title, Image, Runtime) in Movie:
							Runtime = Runtime.replace('h','').replace('m','').replace('s','').strip()
							if Image.startswith('//'):
								Image = "http:" + Image
							self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, '', ''))
			else:
				if not 'private' in item:
					Movie = MPfindall(self, 'href="(.*?)" title="(.*?)".*?(?:src|data-original)="(?!data:image/)(.*?)".*?(class="duration">(.*?)</div>.*?class="added">(?:<em>|)(.*?)(?:</em>|)</div>.*?$)', item, re.S)
					if Movie:
						for (Url, Title, Image, Meta, Runtime, Added) in Movie:
							if self.portal == "PornFD.com":
								stop = False
								for x in self.blacklist:
									if x.lower() in Title.lower():
										stop = True
								if stop:
									continue
							Views = re.search('.*?class="views">(.*?)</div>', Meta)
							if Views:
								Views = stripAllTags(Views.group(1).replace(' ','').replace('views','')).strip()
							else:
								Views = ''
							Runtime = Runtime.replace('h','').replace('m','').replace('s','')
							if Image.startswith('//'):
								Image = "http:" + Image
							Added = stripAllTags(Added)
							self.filmliste.append((decodeHtml(Title), Url, Image, Runtime, Views, Added))
		if len(self.filmliste) == 0:
			self.filmliste.append((_('No videos found!'), None, None, '', '', ''))
		self.ml.setList(map(self._defaultlistleft, self.filmliste))
		self.ml.moveToIndex(0)
		self.keyLocked = False
		self.th_ThumbsQuery(self.filmliste, 0, 1, 2, None, None, self.page, self.lastpage, mode=1)
		self.showInfos()

	def showInfos(self):
		title = self['liste'].getCurrent()[0][0]
		url = self['liste'].getCurrent()[0][1]
		pic = self['liste'].getCurrent()[0][2]
		runtime = self['liste'].getCurrent()[0][3]
		views = self['liste'].getCurrent()[0][4]
		added = self['liste'].getCurrent()[0][5]
		self['name'].setText(title)
		if added:
			added = "\nAdded: %s" % added
		if views:
			views = "\nViews: %s" % views
		self['handlung'].setText("Runtime: %s%s%s" % (runtime, added, views))
		CoverHelper(self['coverArt']).getCover(pic)

	def keyOK(self):
		if self.keyLocked:
			return
		Link = self['liste'].getCurrent()[0][1]
		if Link:
			if not LoggedIn and self.portal in ["0DayPorn.com", "DatoPorn.com"] and username and password:
				self.Login(Link)
			else:
				self['name'].setText(_('Please wait...'))
				twAgentGetPage(Link, agent=agent, cookieJar=cookies).addCallback(self.parseVideo).addErrback(self.dataError)

	def Login(self, url):
		self['name'].setText(_('Please wait...'))
		loginUrl = "%s/login/" % self.baseurl
		loginData = {'action': "login", 'pass': password, 'remember_me': 1, 'username': username, 'format': "json", 'mode': "async", 'email_link': "%s/email/" % self.baseurl}
		twAgentGetPage(loginUrl, agent=agent, method='POST', postdata=urlencode(loginData), cookieJar=cookies, timeout=30, headers={'Content-Type':'application/x-www-form-urlencoded'}).addCallback(self.Login2, url).addErrback(self.dataError)

	def Login2(self, data, url):
		if '"status":"success",' in data:
			global LoggedIn
			LoggedIn = True
		self.keyLocked = True
		twAgentGetPage(url, agent=agent, cookieJar=cookies).addCallback(self.parseVideo).addErrback(self.dataError)

	def parseVideo(self, data):
		Title = self['liste'].getCurrent()[0][0]
		mp_globals.player_agent = agent
		license = MPfindall(self, 'license_code:\s\'(.*?)\',', data, re.S)
		url = MPfindall(self, 'video_(?:alt_|)url\d{0,1}:\s\'(.*?)\'.*?video_(?:alt_|)url\d{0,1}_text:\s\'(\d+)(?:p|)(?: HD|)\',', data, re.S)
		if not url:
			url = MPfindall(self, 'video_(?:alt_|)url\d{0,1}:\s\'(.*?)\'', data, re.S)
		if license and url:
			try:
				max = 0
				for vid in url:
					if int(vid[1]) > max and not "login" in vid[0]:
						if mp_globals.model in ["one","two"]:
							max = int(vid[1])
							url = vid[0]
						elif int(vid[1]) <= 1080:
							max = int(vid[1])
							url = vid[0]
			except:
				if not "login" in url[-1]:
					url = url[-1]
				else:
					url = url[-2]
			if 'function/0/' in url:
				url = decrypturl(url, license[0])
			if url:
				tw_agent_hlp = TwAgentHelper(cookieJar=cookies)
				tw_agent_hlp.getRedirectedUrl(url).addCallback(self.getStream).addErrback(self.dataError)
		else:
			raw = re.findall("<source(?: data-fluid-hd|) src='(.*?)'", data, re.S)
			if raw:
				url = raw[-1]
				tw_agent_hlp = TwAgentHelper(cookieJar=cookies)
				tw_agent_hlp.getRedirectedUrl(url).addCallback(self.getStream).addErrback(self.dataError)
			else:
				message = self.session.open(MessageBoxExt, _("Stream not found"), MessageBoxExt.TYPE_INFO, timeout=5)

	def getStream(self, url):
		Title = self['liste'].getCurrent()[0][0]
		Link = self['liste'].getCurrent()[0][1]
		self['name'].setText(Title)
		import requests
		ck = requests.utils.dict_from_cookiejar(cookies)
		headers = '&Cookie=%s' % ','.join(['%s=%s' % (key, urllib.quote_plus(ck[key])) for key in ck])
		headers = headers + '&Referer=%s' % Link
		if url.startswith('//'):
			url = 'https:' + url
		url = url + '#User-Agent='+agent+headers
		mp_globals.player_agent = agent
		self.session.open(SimplePlayer, [(Title, url)], showPlaylist=False, ltype='slutload')
		self.keyLocked = False